#ifndef _MATCH_STRUCTURE_H_
#define _MATCH_STRUCTURE_H_

#include <vector>

struct Matched
{
    Matched(unsigned long long pos = 0, unsigned long size = 0) : _pos(pos), _size(size)
    {
    }

    unsigned long long _pos;
    unsigned long _size;
};

typedef std::vector<Matched> MatchType;

inline bool ComparePos(const Matched& left_, const Matched& right_)
{
   return (left_._pos < right_._pos);
}

inline bool CompareSize(const Matched& left_, const Matched& right_)
{
   return (left_._size < right_._size);
}

inline bool Equal(const Matched& left_, const Matched& right_)
{
   return (left_._pos == right_._pos && left_._size == right_._size);
}

#endif // _MATCH_STRUCTURE_H_