#ifndef YY_ExpressionParserImpl_h_included
#define YY_ExpressionParserImpl_h_included
/* before anything */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif
#ifdef __cplusplus
#ifndef YY_USE_CLASS
#define YY_USE_CLASS
#endif
#else
#endif
#include <stdio.h>

#include "expressions.hpp"
#include "utils.h"
#define YY_ExpressionParserImpl_ERROR_BODY  =0
#define YY_ExpressionParserImpl_LEX_BODY  =0

typedef union {
   int size_type_;
   std::wstring* sought_;
   Expression* expression_;
} yy_ExpressionParserImpl_stype;
#define YY_ExpressionParserImpl_STYPE yy_ExpressionParserImpl_stype
#define YY_ExpressionParserImpl_MEMBERS  protected: Expression* expression_; bool caseSensitive_;
 /* %{ and %header{ and %union, during decl */
#ifndef YY_ExpressionParserImpl_COMPATIBILITY
#ifndef YY_USE_CLASS
#define  YY_ExpressionParserImpl_COMPATIBILITY 1
#else
#define  YY_ExpressionParserImpl_COMPATIBILITY 0
#endif
#endif

#if YY_ExpressionParserImpl_COMPATIBILITY != 0
/* backward compatibility */
#ifdef YYLTYPE
#ifndef YY_ExpressionParserImpl_LTYPE
#define YY_ExpressionParserImpl_LTYPE YYLTYPE
/* WARNING obsolete !!! user defined YYLTYPE not reported into generated header */
/* use %define LTYPE */
#endif
#endif
#ifdef YYSTYPE
#ifndef YY_ExpressionParserImpl_STYPE 
#define YY_ExpressionParserImpl_STYPE YYSTYPE
/* WARNING obsolete !!! user defined YYSTYPE not reported into generated header */
/* use %define STYPE */
#endif
#endif
#ifdef YYDEBUG
#ifndef YY_ExpressionParserImpl_DEBUG
#define  YY_ExpressionParserImpl_DEBUG YYDEBUG
/* WARNING obsolete !!! user defined YYDEBUG not reported into generated header */
/* use %define DEBUG */
#endif
#endif
#ifdef YY_ExpressionParserImpl_STYPE
#ifndef yystype
#define yystype YY_ExpressionParserImpl_STYPE
#endif
#endif
/* use goto to be compatible */
#ifndef YY_ExpressionParserImpl_USE_GOTO
#define YY_ExpressionParserImpl_USE_GOTO 1
#endif
#endif

/* use no goto to be clean in C++ */
#ifndef YY_ExpressionParserImpl_USE_GOTO
#define YY_ExpressionParserImpl_USE_GOTO 0
#endif

#ifndef YY_ExpressionParserImpl_PURE
#define YY_ExpressionParserImpl_PURE 1

/* YY_ExpressionParserImpl_PURE */
#endif
/* prefix */
#ifndef YY_ExpressionParserImpl_DEBUG
/* YY_ExpressionParserImpl_DEBUG */
#endif
#ifndef YY_ExpressionParserImpl_LSP_NEEDED
 /* YY_ExpressionParserImpl_LSP_NEEDED*/
#endif
/* DEFAULT LTYPE*/
#ifdef YY_ExpressionParserImpl_LSP_NEEDED
#ifndef YY_ExpressionParserImpl_LTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YY_ExpressionParserImpl_LTYPE yyltype
#endif
#endif
/* DEFAULT STYPE*/
#ifndef YY_ExpressionParserImpl_STYPE
#define YY_ExpressionParserImpl_STYPE int
#endif
/* DEFAULT MISCELANEOUS */
#ifndef YY_ExpressionParserImpl_PARSE
#define YY_ExpressionParserImpl_PARSE yyparse
#endif
#ifndef YY_ExpressionParserImpl_LEX
#define YY_ExpressionParserImpl_LEX yylex
#endif
#ifndef YY_ExpressionParserImpl_LVAL
#define YY_ExpressionParserImpl_LVAL yylval
#endif
#ifndef YY_ExpressionParserImpl_LLOC
#define YY_ExpressionParserImpl_LLOC yylloc
#endif
#ifndef YY_ExpressionParserImpl_CHAR
#define YY_ExpressionParserImpl_CHAR yychar
#endif
#ifndef YY_ExpressionParserImpl_NERRS
#define YY_ExpressionParserImpl_NERRS yynerrs
#endif
#ifndef YY_ExpressionParserImpl_DEBUG_FLAG
#define YY_ExpressionParserImpl_DEBUG_FLAG yydebug
#endif
#ifndef YY_ExpressionParserImpl_ERROR
#define YY_ExpressionParserImpl_ERROR yyerror
#endif

#ifndef YY_ExpressionParserImpl_PARSE_PARAM
#ifndef __STDC__
#ifndef __cplusplus
#ifndef YY_USE_CLASS
#define YY_ExpressionParserImpl_PARSE_PARAM
#ifndef YY_ExpressionParserImpl_PARSE_PARAM_DEF
#define YY_ExpressionParserImpl_PARSE_PARAM_DEF
#endif
#endif
#endif
#endif
#ifndef YY_ExpressionParserImpl_PARSE_PARAM
#define YY_ExpressionParserImpl_PARSE_PARAM void
#endif
#endif

/* TOKEN C */
#ifndef YY_USE_CLASS

#ifndef YY_ExpressionParserImpl_PURE
extern YY_ExpressionParserImpl_STYPE YY_ExpressionParserImpl_LVAL;
#endif

#define	Sought	258
#define	TOK_SIZE	259
#define	OR	260
#define	AND	261
#define	NEAR1	262
#define	NOT	263
#define	OPEN	264
#define	CLOSE	265
#define	BACK_SLASH	266

 /* #defines token */
/* after #define tokens, before const tokens S5*/
#else
#ifndef YY_ExpressionParserImpl_CLASS
#define YY_ExpressionParserImpl_CLASS ExpressionParserImpl
#endif

#ifndef YY_ExpressionParserImpl_INHERIT
#define YY_ExpressionParserImpl_INHERIT
#endif
#ifndef YY_ExpressionParserImpl_MEMBERS
#define YY_ExpressionParserImpl_MEMBERS 
#endif
#ifndef YY_ExpressionParserImpl_LEX_BODY
#define YY_ExpressionParserImpl_LEX_BODY  
#endif
#ifndef YY_ExpressionParserImpl_ERROR_BODY
#define YY_ExpressionParserImpl_ERROR_BODY  
#endif
#ifndef YY_ExpressionParserImpl_CONSTRUCTOR_PARAM
#define YY_ExpressionParserImpl_CONSTRUCTOR_PARAM
#endif
/* choose between enum and const */
#ifndef YY_ExpressionParserImpl_USE_CONST_TOKEN
#define YY_ExpressionParserImpl_USE_CONST_TOKEN 0
/* yes enum is more compatible with flex,  */
/* so by default we use it */ 
#endif
#if YY_ExpressionParserImpl_USE_CONST_TOKEN != 0
#ifndef YY_ExpressionParserImpl_ENUM_TOKEN
#define YY_ExpressionParserImpl_ENUM_TOKEN yy_ExpressionParserImpl_enum_token
#endif
#endif

class YY_ExpressionParserImpl_CLASS YY_ExpressionParserImpl_INHERIT
{
public: 
#if YY_ExpressionParserImpl_USE_CONST_TOKEN != 0
/* static const int token ... */
static const int Sought;
static const int TOK_SIZE;
static const int OR;
static const int AND;
static const int NEAR1;
static const int NOT;
static const int OPEN;
static const int CLOSE;
static const int BACK_SLASH;

 /* decl const */
#else
enum YY_ExpressionParserImpl_ENUM_TOKEN { YY_ExpressionParserImpl_NULL_TOKEN=0
	,Sought=258
	,TOK_SIZE=259
	,OR=260
	,AND=261
	,NEAR1=262
	,NOT=263
	,OPEN=264
	,CLOSE=265
	,BACK_SLASH=266

 /* enum token */
     }; /* end of enum declaration */
#endif
public:
 int YY_ExpressionParserImpl_PARSE(YY_ExpressionParserImpl_PARSE_PARAM);
 virtual void YY_ExpressionParserImpl_ERROR(char *msg) YY_ExpressionParserImpl_ERROR_BODY;
#ifdef YY_ExpressionParserImpl_PURE
#ifdef YY_ExpressionParserImpl_LSP_NEEDED
 virtual int  YY_ExpressionParserImpl_LEX(YY_ExpressionParserImpl_STYPE *YY_ExpressionParserImpl_LVAL,YY_ExpressionParserImpl_LTYPE *YY_ExpressionParserImpl_LLOC) YY_ExpressionParserImpl_LEX_BODY;
#else
 virtual int  YY_ExpressionParserImpl_LEX(YY_ExpressionParserImpl_STYPE *YY_ExpressionParserImpl_LVAL) YY_ExpressionParserImpl_LEX_BODY;
#endif
#else
 virtual int YY_ExpressionParserImpl_LEX() YY_ExpressionParserImpl_LEX_BODY;
 YY_ExpressionParserImpl_STYPE YY_ExpressionParserImpl_LVAL;
#ifdef YY_ExpressionParserImpl_LSP_NEEDED
 YY_ExpressionParserImpl_LTYPE YY_ExpressionParserImpl_LLOC;
#endif
 int YY_ExpressionParserImpl_NERRS;
 int YY_ExpressionParserImpl_CHAR;
#endif
#if YY_ExpressionParserImpl_DEBUG != 0
public:
 int YY_ExpressionParserImpl_DEBUG_FLAG;	/*  nonzero means print parse trace	*/
#endif
public:
 YY_ExpressionParserImpl_CLASS(YY_ExpressionParserImpl_CONSTRUCTOR_PARAM);
public:
 YY_ExpressionParserImpl_MEMBERS 
};
/* other declare folow */
#endif


#if YY_ExpressionParserImpl_COMPATIBILITY != 0
/* backward compatibility */
#ifndef YYSTYPE
#define YYSTYPE YY_ExpressionParserImpl_STYPE
#endif

#ifndef YYLTYPE
#define YYLTYPE YY_ExpressionParserImpl_LTYPE
#endif
#ifndef YYDEBUG
#ifdef YY_ExpressionParserImpl_DEBUG 
#define YYDEBUG YY_ExpressionParserImpl_DEBUG
#endif
#endif

#endif
/* END */
#endif
