%name ExpressionParserImpl

%header{
#include "expressions.hpp"
#include "utils.h"
%}

%define ERROR_BODY =0
%define LEX_BODY =0

%pure_parser

%union {
   int size_type_;
   std::wstring* sought_;
   Expression* expression_;
}

%define MEMBERS protected: Expression* expression_; bool caseSensitive_;

%type < expression_ > SoughtExpression AndExpression NearExpression NotExpression PrimaryExpression;

%token < sought_ > Sought
%token <size_type_> TOK_SIZE
%token OR AND NEAR1 NOT OPEN CLOSE BACK_SLASH

%start Expression

%%

Expression
   : SoughtExpression {
      expression_ = $1;
   }
;

SoughtExpression
   : SoughtExpression OR AndExpression {
      $$ = new OrExpression( $1, $3 );
   }
   | AndExpression
;

AndExpression
   : AndExpression NotExpression {
      $$ = new AndExpression( $1, $2 );
   }
   | AndExpression AND NotExpression {
      $$ = new AndExpression( $1, $3 );
   }
   | NotExpression
;

NotExpression
   : NOT NearExpression {
      $$ = new NotExpression( $2 );
   }
   | NearExpression
;

NearExpression
   : NearExpression NEAR1 BACK_SLASH TOK_SIZE PrimaryExpression{
      $$ = new NearExpression( $1, $5, $4 );
   }
   | PrimaryExpression
;

PrimaryExpression
   : OPEN SoughtExpression CLOSE {
      $$ = $2;
   }
   | Sought {
      if ( !caseSensitive_) toLower(*$1);
      $$ = new SoughtExpression( *$1 );
      delete $1;
   }
;

%%


