
#include <cstdio>

#include "matcher.hpp"

int main(int argc, char** argv)
{
	const wchar_t query[] = L"foo AND ( bar OR quux )";

    // Parse search query
	ExpressionParser parser(query, wcslen(query), false); 
    
    // Initialize matcher
	BooleanMatcher matcher(parser, false);

    // Input text
	const wchar_t text[] = L"jdfhgusdhfgjksdghrfjhiodfjgbkldfhfootuxcklnvsdh sduibarrgysiudfhguisdhrt iv";

    
    // For each character of input text call feedCharacter
	const wchar_t* ptr = text;
	while (*ptr++)
	{
		matcher.feedCharacter(*ptr);
	}

    // Check if text matches our search query
	if (matcher.evaluate())
	{
		printf("evaluate() == true\n");

        // Get positions where search terms were found
		MatchType res;
		matcher.match(res);

		printf("Match positions:\n");
		for(int i = 0; i < res.size(); i++)
		{
			printf("offset - %I64d, size - %d\n", res[i]._pos, res[i]._size);
		}
	}
	else
	{
		printf("evaluate() == false\n");
	}
}